import 'dart:async';

import 'package:fk_user_agent/fk_user_agent.dart';
import 'package:flutter/material.dart';
import 'package:flutter/services.dart';
// import 'package:flutter_user_agent/flutter_user_agent.dart';
import 'package:share_apps/widgets/widgets_importer.dart';
import 'package:webview_flutter/webview_flutter.dart';

import 'invitaion_complete_screen.dart';

class InviteEmail extends StatefulWidget {
  String url;
  // String first_loaded_url;
  bool isProgressShow = true, isFirst = true;

  InviteEmail(
    this.url,
  );

  @override
  _InviteEmailState createState() => _InviteEmailState();
}

class _InviteEmailState extends State<InviteEmail> {
  final Completer<WebViewController> _controller =
      Completer<WebViewController>();
  String _userAgent = '<unknown>', _webUserAgent = '<unknown>';
  late WebViewController controller;

  final GlobalKey scaffoldState = GlobalKey<ScaffoldState>();

  void initWebController() {
    controller = WebViewController()
      ..setJavaScriptMode(JavaScriptMode.unrestricted)
      ..addJavaScriptChannel(
        'Toaster',
        onMessageReceived: (JavaScriptMessage message) {
          ScaffoldMessenger.of(scaffoldState.currentContext!).showSnackBar(
            SnackBar(content: Text(message.message)),
          );
        },
      )
      ..setNavigationDelegate(
        NavigationDelegate(
          onProgress: (int progress) {
            // Update loading bar.
          },
          onPageStarted: (String url) {
            setState(() {
              widget.isProgressShow = true;
            });
          },
          onPageFinished: (String url) {
            setState(() {
              widget.isProgressShow = false;
            });
          },
          // onWebResourceError: (WebResourceError error) {},
          onNavigationRequest: (NavigationRequest request) {
            return NavigationDecision.navigate;
          },
        ),
      )
      ..loadRequest(
        Uri.parse(widget.url),
      );
  }

  @override
  void initState() {
    super.initState();
    initWebController();
    initUserAgentState();
  }

  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      debugShowCheckedModeBanner: false,
      color: Colors.white,
      home: Scaffold(
        appBar: AppBar(
          backgroundColor: Colors.white,
          leading: InkWell(
            onTap: () {
              Navigator.pop(context);
            },
            child: Icon(
              Icons.arrow_back,
              color: Colors.black,
              size: 24,
            ),
          ),
          elevation: 0,
          title: Text(
            'Invite by Email',
            style: TextStyle(color: Colors.black),
          ),
          actions: <Widget>[
            IconButton(
              icon: const Icon(
                Icons.done,
                color: Colors.black,
              ),
              onPressed: () {
                Route route = MaterialPageRoute(
                    builder: (context) => InvitationComplete());
                Navigator.pushReplacement(context, route);
              },
            ),
          ],
        ),
        body: Builder(builder: (BuildContext context) {
          return Stack(
            children: <Widget>[
              WebViewWidget(
                controller: controller,
                // userAgent: _userAgent,
                // initialUrl: widget.url,
                // // javascriptMode: JavascriptMode.unrestricted,
                // onWebViewCreated: (WebViewController webViewController) {
                //   _controller.complete(webViewController);
                // },
                // javascriptChannels: <JavascriptChannel>[
                //   _toasterJavascriptChannel(context),
                // ].toSet(),
                // navigationDelegate: (NavigationRequest request) {
                //   return NavigationDecision.navigate;
                // },
                // onPageStarted: (String url) {
                //   setState(() {
                //     widget.isProgressShow = true;
                //   });
                // },
                // onPageFinished: (String url) {
                //   setState(() {
                //     widget.isProgressShow = false;
                //   });
                // },
                // gestureNavigationEnabled: true,
              ),
              Visibility(visible: widget.isProgressShow, child: addProgress())
            ],
          );
        }),
      ),
    );
  }

  // _toasterJavascriptChannel(BuildContext context) {
  //   return JavascriptChannel(
  //       name: 'Toaster',
  //       onMessageReceived: (JavascriptMessage message) {
  //         ScaffoldMessenger.of(context).showSnackBar(
  //           SnackBar(content: Text(message.message)),
  //         );
  //       });
  // }

//   Future<void> initUserAgentState() async {
//     String userAgent, webViewUserAgent;
//     try {
//       userAgent = await FlutterUserAgent.getPropertyAsync('userAgent');
//       await FlutterUserAgent.init();
//       webViewUserAgent = FlutterUserAgent.webViewUserAgent;
//       print('''
// --- applicationVersion => ${FlutterUserAgent.getProperty('applicationVersion')}
// --- systemName         => ${FlutterUserAgent.getProperty('systemName')}
// --- userAgent          => $userAgent
// --- webViewUserAgent   => $webViewUserAgent
// --- packageUserAgent   => ${FlutterUserAgent.getProperty('packageUserAgent')}
//       ''');
//     } on PlatformException {
//       userAgent = webViewUserAgent = '<error>';
//     }
//     if (!mounted) return;
//     setState(() {
//       _userAgent = userAgent;
//       _webUserAgent = webViewUserAgent;
//     });
//   }
// }

  Future<void> initUserAgentState() async {
    String userAgent, webViewUserAgent;
    try {
      userAgent = await FkUserAgent.getPropertyAsync('userAgent');
      await FkUserAgent.init();
      webViewUserAgent = FkUserAgent.webViewUserAgent ?? '<error>';
      print('''
--- applicationVersion => ${FkUserAgent.getProperty('applicationVersion')}
--- systemName         => ${FkUserAgent.getProperty('systemName')}
--- userAgent          => $userAgent
--- webViewUserAgent   => $webViewUserAgent
--- packageUserAgent   => ${FkUserAgent.getProperty('packageUserAgent')}
      ''');
    } on PlatformException {
      userAgent = webViewUserAgent = '<error>';
    }
    if (!mounted) return;
    setState(() {
      _userAgent = userAgent;
      _webUserAgent = webViewUserAgent;
    });
  }
}

// enum MenuOptions {
//   showUserAgent,
//   listCookies,
//   clearCookies,
//   addToCache,
//   listCache,
//   clearCache,
//   navigationDelegate,
// }
